manage 16 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck disable=SC2031
  5. # shellcheck source=utils/lib.sh
  6. source "$(dirname "${BASH_SOURCE[0]}")/utils/lib.sh"
  7. # shellcheck source=utils/brand.env
  8. source "${REPO_ROOT}/utils/brand.env"
  9. source_dot_config
  10. # config
  11. PYOBJECTS="searx"
  12. PY_SETUP_EXTRAS='[test]'
  13. NPM_PACKAGES="less@2.7 less-plugin-clean-css grunt-cli"
  14. GECKODRIVER_VERSION="v0.28.0"
  15. # SPHINXOPTS=
  16. pylint.FILES() {
  17. # List files tagged by comment:
  18. #
  19. # # lint: pylint
  20. #
  21. # These py files are linted by test.pylint(), all other files are linted by
  22. # test.pep8()
  23. grep -l -r --include \*.py '^#[[:blank:]]*lint:[[:blank:]]*pylint' searx searx_extra tests
  24. }
  25. YAMLLINT_FILES=()
  26. while IFS= read -r line; do
  27. YAMLLINT_FILES+=("$line")
  28. done <<< "$(git ls-files './tests/*.yml' './searx/*.yml' './utils/templates/etc/searx/*.yml')"
  29. PYLINT_SEARX_DISABLE_OPTION="\
  30. I,C,R,\
  31. W0105,W0212,W0511,W0603,W0613,W0621,W0702,W0703,W1401,\
  32. E1136"
  33. PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES="supported_languages,language_aliases"
  34. PYLINT_OPTIONS="-m pylint -j 0 --rcfile .pylintrc"
  35. help() {
  36. cat <<EOF
  37. buildenv
  38. rebuild ./utils/brand.env
  39. babel.compile
  40. pybabel compile ./searx/translations
  41. data.*
  42. all : update searx/languages.py and ./data/*
  43. languages : update searx/data/engines_languages.json & searx/languages.py
  44. useragents: update searx/data/useragents.json with the most recent versions of Firefox.
  45. docs.*
  46. html : build HTML documentation
  47. live : autobuild HTML documentation while editing
  48. gh-pages : deploy on gh-pages branch
  49. prebuild : build reST include files (./${DOCS_BUILD}/includes)
  50. clean : clean documentation build
  51. docker
  52. build : build docker image
  53. push : build and push docker image
  54. gecko.driver
  55. download & install geckodriver if not already installed (required for
  56. robot_tests)
  57. node.*
  58. env : download & install npm dependencies locally
  59. clean : drop npm installations
  60. py.*
  61. build : Build python packages at ./${PYDIST}
  62. clean : delete virtualenv and intermediate py files
  63. pyenv.* :
  64. install : developer install of searx into virtualenv
  65. uninstall : uninstall developer installation
  66. cmd ... : run command ... in virtualenv
  67. OK : test if virtualenv is OK
  68. pypi.upload:
  69. Upload python packages to PyPi (to test use pypi.upload.test)
  70. test.* :
  71. pylint : lint PYLINT_FILES, searx/engines, searx & tests
  72. pep8 : pycodestyle (pep8) for all files except PYLINT_FILES
  73. unit : run unit tests
  74. coverage : run unit tests with coverage
  75. robot : run robot test
  76. clean : clean intermediate test stuff
  77. themes.* :
  78. all : build all themes
  79. oscar : build oscar theme
  80. simple : build simple theme
  81. EOF
  82. }
  83. if [ "$VERBOSE" = "1" ]; then
  84. SPHINX_VERBOSE="-v"
  85. PYLINT_VERBOSE="-v"
  86. fi
  87. # needed by sphinx-docs
  88. export DOCS_BUILD
  89. buildenv() {
  90. SEARX_DEBUG=1 pyenv.cmd python utils/build_env.py 2>&1 \
  91. | prefix_stdout "${_Blue}BUILDENV${_creset} "
  92. return "${PIPESTATUS[0]}"
  93. }
  94. babel.compile() {
  95. build_msg BABEL compile
  96. pyenv.cmd pybabel compile -d "${REPO_ROOT}/searx/translations"
  97. dump_return $?
  98. }
  99. data.all() {
  100. data.languages
  101. data.useragents
  102. data.osm_keys_tags
  103. build_msg DATA "update searx/data/ahmia_blacklist.txt"
  104. pyenv.cmd python searx_extra/update/update_ahmia_blacklist.py
  105. build_msg DATA "update searx/data/wikidata_units.json"
  106. pyenv.cmd python searx_extra/update/update_wikidata_units.py
  107. build_msg DATA "update searx/data/currencies.json"
  108. pyenv.cmd python searx_extra/update/update_currencies.py
  109. }
  110. data.languages() {
  111. ( set -e
  112. build_msg ENGINES "fetch languages .."
  113. pyenv.cmd python searx_extra/update/update_languages.py
  114. build_msg ENGINES "update update searx/languages.py"
  115. build_msg DATA "update searx/data/engines_languages.json"
  116. )
  117. dump_return $?
  118. }
  119. data.useragents() {
  120. build_msg DATA "update searx/data/useragents.json"
  121. pyenv.cmd python searx_extra/update/update_firefox_version.py
  122. dump_return $?
  123. }
  124. data.osm_keys_tags() {
  125. build_msg DATA "update searx/data/osm_keys_tags.json"
  126. pyenv.cmd python searx_extra/update/update_osm_keys_tags.py
  127. dump_return $?
  128. }
  129. docs.prebuild() {
  130. build_msg DOCS "build ${DOCS_BUILD}/includes"
  131. (
  132. set -e
  133. [ "$VERBOSE" = "1" ] && set -x
  134. mkdir -p "${DOCS_BUILD}/includes"
  135. ./utils/searx.sh doc | cat > "${DOCS_BUILD}/includes/searx.rst"
  136. ./utils/filtron.sh doc | cat > "${DOCS_BUILD}/includes/filtron.rst"
  137. ./utils/morty.sh doc | cat > "${DOCS_BUILD}/includes/morty.rst"
  138. )
  139. dump_return $?
  140. }
  141. docker.push() {
  142. docker.build push
  143. }
  144. docker.buildx() {
  145. docker.build buildx
  146. }
  147. # shellcheck disable=SC2119
  148. docker.build() {
  149. pyenv.install
  150. build_msg DOCKER build
  151. # run installation in a subprocess and activate pyenv
  152. # See https://www.shellcheck.net/wiki/SC1001 and others ..
  153. # shellcheck disable=SC2031,SC2230,SC2002,SC2236,SC2143,SC1001
  154. ( set -e
  155. # shellcheck source=/dev/null
  156. source "${PY_ENV_BIN}/activate"
  157. # Check if it is a git repository
  158. if [ ! -d .git ]; then
  159. die 1 "This is not Git repository"
  160. fi
  161. if [ ! -x "$(which git)" ]; then
  162. die 1 "git is not installed"
  163. fi
  164. if ! git remote get-url origin 2> /dev/null; then
  165. die 1 "there is no remote origin"
  166. fi
  167. # This is a git repository
  168. # "git describe" to get the Docker version (for example : v0.15.0-89-g0585788e)
  169. # awk to remove the "v" and the "g"
  170. SEARX_GIT_VERSION=$(git describe --match "v[0-9]*\.[0-9]*\.[0-9]*" HEAD 2>/dev/null | awk -F'-' '{OFS="-"; $1=substr($1, 2); if ($3) { $3=substr($3, 2); } print}')
  171. # add the suffix "-dirty" if the repository has uncommited change
  172. # /!\ HACK for searx/searx: ignore utils/brand.env
  173. git update-index -q --refresh
  174. if [ ! -z "$(git diff-index --name-only HEAD -- | grep -v 'utils/brand.env')" ]; then
  175. SEARX_GIT_VERSION="${SEARX_GIT_VERSION}-dirty"
  176. fi
  177. # Get the last git commit id, will be added to the Searx version (see Dockerfile)
  178. VERSION_GITCOMMIT=$(echo "$SEARX_GIT_VERSION" | cut -d- -f2-4)
  179. build_msg DOCKER "Last commit : $VERSION_GITCOMMIT"
  180. # Check consistency between the git tag and the searx/version.py file
  181. # /! HACK : parse Python file with bash /!
  182. # otherwise it is not possible build the docker image without all Python
  183. # dependencies ( version.py loads __init__.py )
  184. # SEARX_PYTHON_VERSION=$(python3 -c "import six; import searx.version; six.print_(searx.version.VERSION_STRING)")
  185. SEARX_PYTHON_VERSION=$(cat searx/version.py | grep "\(VERSION_MAJOR\|VERSION_MINOR\|VERSION_BUILD\) =" | cut -d\= -f2 | sed -e 's/^[[:space:]]*//' | paste -sd "." -)
  186. if [ "$(echo "$SEARX_GIT_VERSION" | cut -d- -f1)" != "$SEARX_PYTHON_VERSION" ]; then
  187. err_msg "git tag: $SEARX_GIT_VERSION"
  188. err_msg "searx/version.py: $SEARX_PYTHON_VERSION"
  189. die 1 "Inconsistency between the last git tag and the searx/version.py file"
  190. fi
  191. # define the docker image name
  192. GITHUB_USER=$(echo "${GIT_URL}" | sed 's/.*github\.com\/\([^\/]*\).*/\1/')
  193. SEARX_IMAGE_NAME="${SEARX_IMAGE_NAME:-${GITHUB_USER:-searxng}/searxng}"
  194. BUILD="build"
  195. if [ "$1" = "buildx" ]; then
  196. # buildx includes the push option
  197. CACHE_TAG="${SEARX_IMAGE_NAME}:latest-build-cache"
  198. BUILD="buildx build --platform linux/amd64,linux/arm64,linux/arm/v7 --push --cache-from=type=registry,ref=$CACHE_TAG --cache-to=type=registry,ref=$CACHE_TAG,mode=max"
  199. shift
  200. fi
  201. build_msg DOCKER "Build command: ${BUILD}"
  202. # build Docker image
  203. build_msg DOCKER "Building image ${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  204. # shellcheck disable=SC2086
  205. docker $BUILD \
  206. --build-arg BASE_IMAGE="${DEPENDENCIES_IMAGE_NAME}" \
  207. --build-arg GIT_URL="${GIT_URL}" \
  208. --build-arg SEARX_GIT_VERSION="${SEARX_GIT_VERSION}" \
  209. --build-arg VERSION_GITCOMMIT="${VERSION_GITCOMMIT}" \
  210. --build-arg LABEL_DATE="$(date -u +"%Y-%m-%dT%H:%M:%SZ")" \
  211. --build-arg LABEL_VCS_REF="$(git rev-parse HEAD)" \
  212. --build-arg LABEL_VCS_URL="${GIT_URL}" \
  213. --build-arg TIMESTAMP_SETTINGS="$(git log -1 --format="%cd" --date=unix -- searx/settings.yml)" \
  214. --build-arg TIMESTAMP_UWSGI="$(git log -1 --format="%cd" --date=unix -- dockerfiles/uwsgi.ini)" \
  215. -t "${SEARX_IMAGE_NAME}:latest" -t "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}" .
  216. if [ "$1" = "push" ]; then
  217. docker push "${SEARX_IMAGE_NAME}:latest"
  218. docker push "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  219. fi
  220. )
  221. dump_return $?
  222. }
  223. # shellcheck disable=SC2119
  224. gecko.driver() {
  225. pyenv.install
  226. build_msg INSTALL "gecko.driver"
  227. # run installation in a subprocess and activate pyenv
  228. ( set -e
  229. # shellcheck source=/dev/null
  230. source "${PY_ENV_BIN}/activate"
  231. # TODO : check the current geckodriver version
  232. geckodriver -V > /dev/null 2>&1 || NOTFOUND=1
  233. set +e
  234. if [ -z "$NOTFOUND" ]; then
  235. build_msg INSTALL "geckodriver already installed"
  236. return
  237. fi
  238. PLATFORM="$(python3 -c 'import platform; print(platform.system().lower(), platform.architecture()[0])')"
  239. case "$PLATFORM" in
  240. "linux 32bit" | "linux2 32bit") ARCH="linux32";;
  241. "linux 64bit" | "linux2 64bit") ARCH="linux64";;
  242. "windows 32 bit") ARCH="win32";;
  243. "windows 64 bit") ARCH="win64";;
  244. "mac 64bit") ARCH="macos";;
  245. esac
  246. GECKODRIVER_URL="https://github.com/mozilla/geckodriver/releases/download/$GECKODRIVER_VERSION/geckodriver-$GECKODRIVER_VERSION-$ARCH.tar.gz";
  247. build_msg GECKO "Installing ${PY_ENV_BIN}/geckodriver from $GECKODRIVER_URL"
  248. FILE="$(mktemp)"
  249. wget -qO "$FILE" -- "$GECKODRIVER_URL" && tar xz -C "${PY_ENV_BIN}" -f "$FILE" geckodriver
  250. rm -- "$FILE"
  251. chmod 755 -- "${PY_ENV_BIN}/geckodriver"
  252. )
  253. dump_return $?
  254. }
  255. node.env() {
  256. local err=0
  257. pushd "${REPO_ROOT}" &> /dev/null
  258. # shellcheck disable=SC2230
  259. which npm &> /dev/null || die 1 'node.env - npm is not found!'
  260. ( set -e
  261. # shellcheck disable=SC2030
  262. PATH="$(npm bin):$PATH"
  263. export PATH
  264. build_msg INSTALL "npm install $NPM_PACKAGES"
  265. # shellcheck disable=SC2086
  266. npm install $NPM_PACKAGES
  267. cd "${REPO_ROOT}/searx/static/themes/oscar"
  268. build_msg INSTALL "($(pwd)) npm install"
  269. npm install
  270. build_msg INSTALL "($(pwd)) npm install"
  271. cd "${REPO_ROOT}/searx/static/themes/simple"
  272. npm install
  273. )
  274. err=$?
  275. popd &> /dev/null
  276. dump_return "$err"
  277. }
  278. node.clean() {
  279. build_msg CLEAN "locally installed npm dependencies"
  280. rm -rf \
  281. ./node_modules \
  282. ./package-lock.json \
  283. ./searx/static/themes/oscar/package-lock.json \
  284. ./searx/static/themes/oscar/node_modules \
  285. ./searx/static/themes/simple/package-lock.json \
  286. ./searx/static/themes/simple/node_modules
  287. dump_return $?
  288. }
  289. py.build() {
  290. build_msg BUILD "[pylint] python package ${PYDIST}"
  291. pyenv.cmd python setup.py \
  292. sdist -d "${PYDIST}" \
  293. bdist_wheel --bdist-dir "${PYBUILD}" -d "${PYDIST}"
  294. }
  295. py.clean() {
  296. build_msg CLEAN pyenv
  297. ( set -e
  298. pyenv.drop
  299. [ "$VERBOSE" = "1" ] && set -x
  300. rm -rf "${PYDIST}" "${PYBUILD}" "${PY_ENV}" ./.tox ./*.egg-info
  301. find . -name '*.pyc' -exec rm -f {} +
  302. find . -name '*.pyo' -exec rm -f {} +
  303. find . -name __pycache__ -exec rm -rf {} +
  304. )
  305. }
  306. pyenv.check() {
  307. cat <<EOF
  308. import yaml
  309. print('import yaml --> OK')
  310. EOF
  311. }
  312. pyenv.install() {
  313. if ! pyenv.OK; then
  314. py.clean > /dev/null
  315. fi
  316. if pyenv.install.OK > /dev/null; then
  317. return 0
  318. fi
  319. ( set -e
  320. pyenv
  321. build_msg PYENV "[install] pip install -e 'searx${PY_SETUP_EXTRAS}'"
  322. "${PY_ENV_BIN}/python" -m pip install -e ".${PY_SETUP_EXTRAS}"
  323. buildenv
  324. )
  325. local exit_val=$?
  326. if [ ! $exit_val -eq 0 ]; then
  327. die 42 "error while pip install (${PY_ENV_BIN})"
  328. fi
  329. }
  330. pyenv.uninstall() {
  331. build_msg PYENV "[pyenv.uninstall] uninstall packages: ${PYOBJECTS}"
  332. pyenv.cmd python setup.py develop --uninstall 2>&1 \
  333. | prefix_stdout "${_Blue}PYENV ${_creset}[pyenv.uninstall] "
  334. }
  335. pypi.upload() {
  336. py.clean
  337. py.build
  338. # https://github.com/pypa/twine
  339. pyenv.cmd twine upload "${PYDIST}"/*
  340. }
  341. pypi.upload.test() {
  342. py.clean
  343. py.build
  344. pyenv.cmd twine upload -r testpypi "${PYDIST}"/*
  345. }
  346. test.yamllint() {
  347. build_msg TEST "[pylint] \$PYLINT_FILES"
  348. pyenv.cmd yamllint --format parsable "${YAMLLINT_FILES[@]}"
  349. }
  350. test.pylint() {
  351. # shellcheck disable=SC2086
  352. ( set -e
  353. build_msg TEST "[pylint] \$PYLINT_FILES"
  354. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  355. "${PYLINT_FILES[@]}"
  356. build_msg TEST "[pylint] searx/engines"
  357. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  358. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  359. --additional-builtins="${PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES}" \
  360. searx/engines
  361. build_msg TEST "[pylint] searx tests"
  362. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  363. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  364. --ignore=searx/engines \
  365. searx tests
  366. )
  367. dump_return $?
  368. }
  369. test.pep8() {
  370. build_msg TEST 'pycodestyle (formerly pep8)'
  371. local _exclude=""
  372. printf -v _exclude '%s, ' "${PYLINT_FILES[@]}"
  373. pyenv.cmd pycodestyle \
  374. --exclude="searx/static, searx/languages.py, $_exclude " \
  375. --max-line-length=120 \
  376. --ignore "E117,E252,E402,E722,E741,W503,W504,W605" \
  377. searx tests
  378. dump_return $?
  379. }
  380. test.unit() {
  381. build_msg TEST 'tests/unit'
  382. pyenv.cmd python -m nose2 -s tests/unit
  383. dump_return $?
  384. }
  385. test.coverage() {
  386. build_msg TEST 'unit test coverage'
  387. ( set -e
  388. pyenv.cmd python -m nose2 -C --log-capture --with-coverage --coverage searx -s tests/unit
  389. pyenv.cmd coverage report
  390. pyenv.cmd coverage html
  391. )
  392. dump_return $?
  393. }
  394. test.robot() {
  395. build_msg TEST 'robot'
  396. gecko.driver
  397. PYTHONPATH=. pyenv.cmd python searx/testing.py robot
  398. dump_return $?
  399. }
  400. test.clean() {
  401. build_msg CLEAN "test stuff"
  402. rm -rf geckodriver.log .coverage coverage/
  403. dump_return $?
  404. }
  405. themes.all() {
  406. ( set -e
  407. node.env
  408. themes.oscar
  409. themes.simple
  410. )
  411. dump_return $?
  412. }
  413. themes.oscar() {
  414. local gruntfile=searx/static/themes/oscar/gruntfile.js
  415. build_msg GRUNT "${gruntfile}"
  416. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  417. dump_return $?
  418. }
  419. themes.simple() {
  420. local gruntfile=searx/static/themes/simple/gruntfile.js
  421. build_msg GRUNT "${gruntfile}"
  422. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  423. dump_return $?
  424. }
  425. PYLINT_FILES=()
  426. while IFS= read -r line; do
  427. PYLINT_FILES+=("$line")
  428. done <<< "$(pylint.FILES)"
  429. # shellcheck disable=SC2119
  430. main() {
  431. local _type
  432. local cmd="$1"; shift
  433. if [ "$cmd" == "" ]; then
  434. help
  435. err_msg "missing command"
  436. return 42
  437. fi
  438. case "$cmd" in
  439. --getenv) var="$1"; echo "${!var}";;
  440. --help) help;;
  441. --*)
  442. help
  443. err_msg "unknown option $cmd"
  444. return 42
  445. ;;
  446. *)
  447. _type="$(type -t "$cmd")"
  448. if [ "$_type" != 'function' ]; then
  449. err_msg "unknown command $1 / use --help"
  450. return 42
  451. else
  452. "$cmd" "$@"
  453. fi
  454. ;;
  455. esac
  456. }
  457. main "$@"